@echo off
REM Launch <Module Passed On Command Line> on a Windows system.
cls
setlocal
set VERSION=2.02
set MODULE_TO_LAUNCH=%1
set INITIAL_HEAP_SIZE=%2
set MAXIMUM_HEAP_SIZE=%3
set STACK_SIZE=%4

echo ---------------------------------------------------
echo %MODULE_TO_LAUNCH% Product Launcher V. %VERSION%
echo ---------------------------------------------------
echo.
set JAR_ARGUMENT=-jar %MODULE_TO_LAUNCH%\Lib\%MODULE_TO_LAUNCH%.jar


if "%MODULE_TO_LAUNCH%"=="" (
	goto usage
)

if "%INITIAL_HEAP_SIZE%" =="" (
	set INITIAL_HEAP_SIZE=64
)

if "%MAXIMUM_HEAP_SIZE%"=="" (
	set MAXIMUM_HEAP_SIZE=1024
)
if "%STACK_SIZE%"=="" (
	set STACK_SIZE=32
)



echo Loading and running %MODULE_TO_LAUNCH%  (This takes a few moments ... )



if "%JAVA_HOME%"=="" goto next0
if not exist "%JAVA_HOME%\bin\java.exe" goto next0
"%JAVA_HOME%\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT%
goto end
:next0


if not exist "C:\Windows\System32\java.exe" goto next1
"C:\Windows\System32\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next1

if not exist "C:\Program Files\Java\jre9\bin\java.exe" goto next2
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next2


if not exist "C:\Program Files (x86)\java\jre9\bin\java.exe" goto next3
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next3

if not exist "C:\Program Files\Java\jre8\bin\java.exe" goto next4
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next4


if not exist "C:\Program Files (x86)\java\jre8\bin\java.exe" goto next5
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next5



if not exist "C:\Program Files\Java\jre7\bin\java.exe" goto next6
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next6


if not exist "C:\Program Files (x86)\java\jre7\bin\java.exe" goto next7
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next7



if not exist "C:\Program Files\Java\jre6\bin\java.exe" goto next8
"C:\Program Files\java\jre6\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next8


if not exist "C:\Program Files (x86)\java\jre6\bin\java.exe" goto next9
"C:\Program Files (x86)\java\jre6\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next9


if not exist "C:\Program Files\Java\jre5\bin\java.exe" goto next10
"C:\Program Files\java\jre5\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next10


if not exist "C:\Program Files (x86)\java\jre5\bin\java.exe" goto next11
"C:\Program Files (x86)\java\jre5\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next11
















if not exist "C:\Program Files\Java\jre9\bin\java.exe" goto next12
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next12


if not exist "C:\Program Files (x86)\java\jre9\bin\java.exe" goto next13
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next13

if not exist "C:\Program Files\Java\jre8\bin\java.exe" goto next14
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next14


if not exist "C:\Program Files (x86)\java\jre8\bin\java.exe" goto next15
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next15



if not exist "C:\Program Files\Java\jre7\bin\java.exe" goto next16
"C:\Program Files\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next16


if not exist "C:\Program Files (x86)\java\jre7\bin\java.exe" goto next17
"C:\Program Files (x86)\java\jre7\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next17



if not exist "C:\Program Files\Java\jre6\bin\java.exe" goto next18
"C:\Program Files\java\jre6\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next18


if not exist "C:\Program Files (x86)\java\jre6\bin\java.exe" goto next19
"C:\Program Files (x86)\java\jre6\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next19


if not exist "C:\Program Files\Java\jre5\bin\java.exe" goto next20
"C:\Program Files\java\jre5\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next20


if not exist "C:\Program Files (x86)\java\jre5\bin\java.exe" goto next21
"C:\Program Files (x86)\java\jre5\bin\java.exe"  -Xms%INITIAL_HEAP_SIZE%M -Xmx%MAXIMUM_HEAP_SIZE%M -Xss%STACK_SIZE%M %JAR_ARGUMENT% 
goto end
:next21


echo.
echo Error : Unable to find a Java Runtime Environment (JRE) capable of launching %MODULE_TO_LAUNCH%.
pause


:end
exit /B 0


:usage
echo.
echo.
echo Usage Run.bat ProductToLaunch  HEAP_SIZE(M) MAX_HEAP_SIZE(M) STACK_SIZE(M)
echo.
echo Eg    Run.bat DataBugs 64 512 32
echo Eg    Run.bat DataBugs 64 1024 64
echo.
pause
goto end